
enum {
    HEAPSIZE = 16*1024,

    RING_SIZE = 4096,

    FLASH_BUFFER = 768,

    _CLKFREQ = 280'000'000,

    AUDIO_LEFT = 8+6,
    AUDIO_RIGHT = AUDIO_LEFT+1,
};

#include <stdlib.h>
#include <stdio.h>
#include "helix/mp3dec.h"

typedef struct {
    short l,r;
} sample_t;


char *mp3ptr;
unsigned flashptr;
size_t mp3left;

MP3FrameInfo info;

unsigned short ring_tail,ring_head;
sample_t ring_buffer[RING_SIZE];

sample_t dec_buffer[MAX_NGRAN*MAX_NSAMP];

char flash_buffer[FLASH_BUFFER];

struct __using("SpiFlash.spin2") flash;


unsigned incmod(unsigned in, unsigned wrap) {
    __asm {
        incmod in,wrap;
    }
    return in;
}


long stack2[128];

void main() {

    _setbaud(2'000'000);
    flash.init(0x10'0000,0xF0'0000,0x1000);
    printf("hello!\n");

    HMP3Decoder decoder = MP3InitDecoder();
    printf("decoder %p\n",decoder);
    if (!decoder) goto oof;

    __builtin_cogstart(bufferplayer(44100),stack2);

    mp3left = 0;
    flashptr = 0;
    while(1) {
        //int newbuf = incmod(buffer_ready,BUFFER_MP3FRAMES-1);
        //while (newbuf == buffer_playing) {}

        // shift and replenish buffer
        if (mp3left > 0) {
            memmove(flash_buffer,flash_buffer+FLASH_BUFFER-mp3left,mp3left);
        }
        if (mp3left < FLASH_BUFFER) {
            flash.read(flash_buffer+mp3left,flashptr,FLASH_BUFFER-mp3left);
            flashptr += FLASH_BUFFER-mp3left;
            mp3left = FLASH_BUFFER;
        }        

        mp3ptr = flash_buffer;
        int time = _getcnt();
        int status = MP3Decode(decoder,&mp3ptr,&mp3left,(short*)dec_buffer,0);
        time = _getcnt() - time;
        //buffer_ready = newbuf;
        //printf("Shitpost status %d - left: %d\n",status,mp3left);
        if (status < 0) goto eof;
        MP3GetLastFrameInfo(decoder,&info);
        //printf("got samples: %d\n",info.outputSamps);
        printf("Frame time: %d - %f%% utilization\n",time,((float)time / (float)__clkfreq_var)*(44100.f / (info.outputSamps>>1))*100.f);

        int copyLeft = info.outputSamps >> 1;
        if (copyLeft) {
            sample_t *ptr = dec_buffer;
            do {
                int new_pos = incmod(ring_head,RING_SIZE-1);
                while (ring_tail == new_pos) {}; // Buffer full
                ring_buffer[new_pos] = *ptr++;
                ring_head = new_pos;
            } while (--copyLeft);
        }

    }
    eof:
    oof:
    printf("done?\n");
    for(;;) {}

}

void bufferplayer(unsigned rate) {
    _wrpin(AUDIO_LEFT,P_DAC_75R_2V|P_OE|P_DAC_DITHER_PWM);
    _wrpin(AUDIO_RIGHT,P_DAC_75R_2V|P_OE|P_DAC_DITHER_PWM);
    rate = __clkfreq_var / rate;
    _wxpin(AUDIO_LEFT,rate);
    _wxpin(AUDIO_RIGHT,rate);
    _wypin(AUDIO_LEFT,0x7F80);
    _wypin(AUDIO_RIGHT,0x7F80);
    _drvl(AUDIO_LEFT);
    _drvl(AUDIO_RIGHT);
    _waitms(500);
    for (;;) {
        while (ring_tail == ring_head) {
            //printf("buffer underrun!\n");
        };
        int left = (ring_buffer[ring_tail].l >> 2) + 0x7F80;
        int right = (ring_buffer[ring_tail].r >> 2) + 0x7F80;
        ring_tail = incmod(ring_tail,RING_SIZE-1);
        while (!_pinr(AUDIO_LEFT)) {}
        _waitx(50);
        _wypin(AUDIO_LEFT,left);
        _wypin(AUDIO_RIGHT,right);

    }
}
